package com.apifon.Examples;

import com.apifon.sdk.Mookee;
import com.apifon.sdk.model.MessageContent;
import com.apifon.sdk.model.SmsRequest;
import com.apifon.sdk.resource.SMSResource;
import com.apifon.sdk.response.GatewayResponse;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonElement;
import com.google.gson.JsonParser;
import java.util.ArrayList;
import java.util.Arrays;

public class DocExample {

    public static void main(String[] args) {

        Mookee.addCredentials("sms", "Your_SMS_Token", "Your_SMS_Secret_Key");
        Mookee.setActiveCredential("sms");

        String[] nums = {"306999999999"/*, "306999999998", "306999999997", ...*/};
        ArrayList<String> numbers = new ArrayList();
        numbers.addAll(Arrays.asList(nums));

        String callback = "https://yourserver/callback";

        SMSResource smsResource = new SMSResource();
        SmsRequest smsRequest = new SmsRequest();

        MessageContent msgContent = new MessageContent();
        msgContent.setText("Hello There!");
        msgContent.setSenderId("Apifon");

        smsRequest.addStrSubscribers(numbers);
        smsRequest.setMessage(msgContent);
        smsRequest.setCallbackUrl(callback);

        System.out.println("Sending Request to Endpoint: /services/sms/send");
        System.out.println("------ SMS Request Body ------\n");
        printJson(smsRequest);
        GatewayResponse response = smsResource.send(smsRequest);
        System.out.println("------ Gateway Response Body ------\n");
        printJson(response);
    }

    private static void printJson(Object object) {
        Gson gson = new GsonBuilder().setPrettyPrinting().create();
        JsonParser jp = new JsonParser();
        JsonElement je = jp.parse(gson.toJson(object));
        String prettyJsonString = gson.toJson(je);
        System.out.println(prettyJsonString);
    }

}
