/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.apifon.sdk.exception;

import com.apifon.sdk.response.OauthTokenErrorResponse;
import java.io.IOException;

/**
 *
 * @author Apifon
 */
public class OAuthTokenException extends OAuthException {

    private final OauthTokenErrorResponse oauthResponse;

    public OAuthTokenException(String message) {
        super(message);
        oauthResponse = null;
    }

    public OAuthTokenException(String message, IOException ex) {
        super(message, ex);
        oauthResponse = null;
    }

    public OAuthTokenException(IOException ex) {
        super(ex);
        oauthResponse = null;
    }

    public OAuthTokenException(String message, OauthTokenErrorResponse resp) {
        super(message);
        this.oauthResponse = resp;
    }

    public OauthTokenErrorResponse getOAuthTokenErrorResponse() {
        return this.oauthResponse;
    }

    /**
     * Prints formatted readable information about the error.
     *
     * @return
     */
    @Override
    public String toString() {
        if (oauthResponse != null) {

            /**
             * Response doesn't contain status code. Return HTTP 400 status code
             * unless invalid_client type that returns HTTP 401 status code
             */
            int status = 400;
            if (oauthResponse.error.equalsIgnoreCase("invalid_client")) {
                status = 401;
            }

            return "Status: " + status + System.lineSeparator()
                    + "Error: " + oauthResponse.error + System.lineSeparator()
                    + "Error description : " + oauthResponse.error_description;

        } else {
            return super.getMessage();
        }
    }

}
