package com.apifon.sdk.model;

import com.google.gson.annotations.SerializedName;
import java.util.HashMap;

/**
 * LandingProperties class represents an apifon_lp Property in subscriber's
 * params.
 */
public class LandingProperties {

    private String url;
    private HashMap<String, String> data;
    private Boolean redirect;
    private String method;
    @SerializedName("prevent_sys_params")
    private Boolean preventSysParams;

    public LandingProperties() {
    }

    /**
     * Returns the URL Parameter.
     *
     * @return the URL.
     */
    public String getUrl() {
        return url;
    }

    /**
     * Sets the URL Parameter.
     *
     * @param url the URL to set.
     */
    public void setUrl(String url) {
        this.url = url;
    }

    /**
     * Returns the data Parameter.
     *
     * @return the data.
     */
    public HashMap<String, String> getData() {
        return data;
    }

    /**
     * Sets the data Parameter.
     *
     * @param data the data to set.
     */
    public void setData(HashMap<String, String> data) {
        this.data = data;
    }

    /**
     * Adds data to the data Map.
     *
     * @param key the key to set.
     * @param value the value to set.
     */
    public void addData(String key, String value) {
        if(this.data == null){
            this.data = new HashMap<>();
        }
        this.data.put(key, value);
    }

    /**
     * Returns the redirect Parameter.
     *
     * @return the redirect.
     */
    public Boolean getRedirect() {
        return redirect;
    }

    /**
     * Sets the redirect Parameter.
     *
     * @param redirect the redirect to set.
     */
    public void setRedirect(Boolean redirect) {
        this.redirect = redirect;
    }

    /**
     * Returns the method Parameter.
     *
     * @return the method.
     */
    public String getMethod() {
        return method;
    }

    /**
     * Sets the method Parameter.
     *
     * @param method the method to set.
     */
    public void setMethod(String method) {
        this.method = method;
    }

    /**
     * Returns the preventSysParams Parameter.
     *
     * @return the preventSysParams.
     */
    public Boolean getPreventSysParams() {
        return preventSysParams;
    }

    /**
     * Sets the preventSysParams Parameter.
     *
     * @param preventSysParams the method to set.
     */
    public void setPreventSysParams(Boolean preventSysParams) {
        this.preventSysParams = preventSysParams;
    }
    
    
}
