package com.apifon.sdk.model;

import com.google.gson.Gson;

/**
 * OtpRequest class represents a OTP Create Request to the APIFON Rest API. You
 * can create an OTPResource object and call it's create() method
 * using a OtpRequest object as a parameter.
 */
public class OtpRequest implements IRequest {

    private String reference_id;
    private String subscriber;
    private Integer code_length;
    private String code_type;
    private String callback_url;
    private Integer expire; //in seconds
    private MessageContent message;

    public OtpRequest() {
        
    }

    /**
     * Returns the reference_id Parameter.
     *
     * @return the reference_id.
     */
    public String getReferenceId() {
        return reference_id;
    }

    /**
     * Sets the reference_id Parameter.
     *
     * @param reference_id the reference_id to set.
     */
    public void setReferenceId(String reference_id) {
        this.reference_id = reference_id;
    }

    /**
     * Returns the subscriber Parameter.
     *
     * @return the subscriber.
     */
    public String getSubscriber() {
        return subscriber;
    }

    /**
     * Sets the subscriber Parameter.
     *
     * @param subscriber the subscriber to set.
     */
    public void setSubscriber(String subscriber) {
        this.subscriber = subscriber;
    }

    /**
     * Returns the code_length Parameter.
     *
     * @return the code_length.
     */
    public int getCodeLenght() {
        return code_length;
    }

    /**
     * Sets the code_length Parameter.
     *
     * @param code_length the code_length to set.
     */
    public void setCodeLenght(int code_length) {
        this.code_length = code_length;
    }

    /**
     * Returns the code_type Parameter.
     *
     * @return the code_type.
     */
    public String getCodeType() {
        return code_type;
    }

    /**
     * Sets the code_type Parameter.
     *
     * @param code_type the code_type to set.
     */
    public void setCodeType(String code_type) {
        this.code_type = code_type;
    }

    /**
     * Returns the callback_url Parameter.
     *
     * @return the callback_url.
     */
    public String getCallbackUrl() {
        return callback_url;
    }

    /**
     * Sets the callback_url Parameter.
     *
     * @param callback_url the callback_url to set.
     */
    public void setCallbackUrl(String callback_url) {
        this.callback_url = callback_url;
    }

    /**
     * Returns the expire Parameter.
     *
     * @return the expire.
     */
    public int getExpire() {
        return expire;
    }

    /**
     * Sets the expire Parameter.
     *
     * @param expire the expire to set.
     */
    public void setExpire(int expire) {
        this.expire = expire;
    }

    /**
     * Returns the message Parameter.
     *
     * @return the message.
     */
    public MessageContent getMessage() {
        return message;
    }

    /**
     * Sets the message Parameter.
     *
     * @param message the message to set.
     */
    public void setMessage(MessageContent message) {
        this.message = message;
    }

    @Override
    public String getBody() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public String getCreateBody() {
        Gson gson = new Gson();
        return gson.toJson(this);
    }

    @Override
    public String getReadBody() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public String getUpdateBody() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public String getDeleteBody() {
        throw new UnsupportedOperationException("Not supported yet.");
    }
}
