package com.apifon.sdk.model;

import com.google.gson.Gson;

/**
 * RemoveRequest class represents a Deletion Request to the APIFON Rest API. You
 * can create an IMResource/SMSResource object and call their remove() method
 * using a RemoveRequest object as a parameter.
 */
public class RemoveRequest implements IRequest {

    private String id;
    private String field;

    public RemoveRequest() {

    }

    /**
     * Returns the id Parameter.
     *
     * @return the id.
     */
    public String getId() {
        return id;
    }

    /**
     * Sets the id Parameter.
     *
     * @param id the id to set.
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * Returns the field Parameter.
     *
     * @return the field.
     */
    public String getField() {
        return field;
    }

    /**
     * Sets the field Parameter.
     *
     * @param field the field to set.
     */
    public void setField(String field) {
        this.field = field;
    }

    @Override
    public String getBody() {
        Gson gson = new Gson();
        return gson.toJson(this);
    }

    @Override
    public String getCreateBody() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public String getReadBody() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public String getUpdateBody() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public String getDeleteBody() {
        throw new UnsupportedOperationException("Not supported yet.");
    }
}
