/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.apifon.sdk.model;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author Apifon
 */
public abstract class SingleResponse {

    private final Map<String, String> meta = new HashMap<>();

    /**
     * Returns an immutable map containing the meta data of the response.
     * May be null.
     * @return
     */
    public Map<String, String> getMeta() {
        return Collections.unmodifiableMap(meta);
    }

    /**
     * Returns the ETag field from the meta. May be null.
     * @return
     */
    public String getEtag() {
        return this.meta.getOrDefault("ETag", null);
    }

}
