package com.apifon.sdk.model;

import com.google.gson.Gson;
import com.google.gson.annotations.SerializedName;

/**
 * SmsRequest class represents an SMS Request to the APIFON Rest API. You can
 * create an SMSResource object and call it's send() method, using an SmsRequest
 * object as a parameter.
 */
public class SmsRequest extends SubscribersViewRequest {

    @SerializedName("reference_id")
    private String referenceId;
    private MessageContent message;
    @SerializedName("callback_url")
    private String callbackUrl;
    private String tte;
    private String date;

    public SmsRequest() {
        this.message = new MessageContent();
    }

    /**
     * Returns the referenceId Parameter.
     *
     * @return the referenceId.
     */
    public String getReferenceId() {
        return referenceId;
    }

    /**
     * Sets the referenceId Parameter.
     *
     * @param referenceId the referenceId to set.
     */
    public void setReferenceId(String referenceId) {
        this.referenceId = referenceId;
    }

    /**
     * Returns the message Parameter.
     *
     * @return the message.
     */
    public MessageContent getMessage() {
        return message;
    }

    /**
     * Sets the message Parameter.
     *
     * @param message the message to set.
     */
    public void setMessage(MessageContent message) {
        this.message = message;
    }

    /**
     * Returns the callbackUrl Parameter.
     *
     * @return the callbackUrl.
     */
    public String getCallbackUrl() {
        return callbackUrl;
    }

    /**
     * Sets the callbackUrl Parameter.
     *
     * @param callbackUrl the callbackUrl to set.
     */
    public void setCallbackUrl(String callbackUrl) {
        this.callbackUrl = callbackUrl;
    }

    /**
     * Returns the TTE Parameter.
     *
     * @return the TTE.
     */
    public String getTte() {
        return tte;
    }

    /**
     * Sets the TTE Parameter.
     *
     * @param tte the TTE to set.
     */
    public void setTte(String tte) {
        this.tte = tte;
    }

    /**
     * Returns the date Parameter.
     *
     * @return the date.
     */
    public String getDate() {
        return date;
    }

    /**
     * Sets the date Parameter.
     *
     * @param date the date to set.
     */
    public void setDate(String date) {
        this.date = date;
    }

    @Override
    public String getBody() {
        Gson gson = new Gson();
        return gson.toJson(this);
    }

    @Override
    public String getCreateBody() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public String getReadBody() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public String getUpdateBody() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public String getDeleteBody() {
        throw new UnsupportedOperationException("Not supported yet.");
    }
}
