package com.apifon.sdk.model;

import com.google.gson.annotations.SerializedName;
import java.util.HashMap;

/**
 * SubscriberInformation class represents a subscriber Property in a SMS/IM
 * Request's subscribers Parameter.
 */
public class SubscriberInformation {

    private String number;
    @SerializedName("custom_id")
    private String customId;
    private HashMap<String, Object> params;

    public SubscriberInformation() {
    }

    /**
     * Returns the number Parameter.
     *
     * @return the number.
     */
    public String getNumber() {
        return number;
    }

    /**
     * Sets the number Parameter.
     *
     * @param number the number to set.
     */
    public void setNumber(String number) {
        this.number = number;
    }

    /**
     * Returns the customId Parameter.
     *
     * @return the customId.
     */
    public String getCustomId() {
        return customId;
    }

    /**
     * Sets the customId Parameter.
     *
     * @param customId the customId to set.
     */
    public void setCustomId(String customId) {
        this.customId = customId;
    }

    /**
     * Returns the params Parameter.
     *
     * @return the params.
     */
    public HashMap<String, Object> getParams() {
        return params;
    }

    /**
     * Sets the params Parameter.
     *
     * @param params the params to set.
     */
    public void setParams(HashMap<String, Object> params) {
        this.params = params;
    }

    /**
     * Adds property to the Param Map.
     *
     * @param key the key to set.
     * @param value the value to set.
     */
    public void setPropertyToParam(String key, String value) {
        if(this.params == null){
            this.params = new HashMap<>();
        }
        this.params.put(key, value);
    }

    /**
     * Returns the apifon_lp Parameter.
     *
     * @return the LandingProperties.
     */
    public LandingProperties getLandingPage() {
        return (LandingProperties) this.params.get("apifon_lp");
    }

    /**
     * Sets the apifon_lp Parameter.
     *
     * @param lp the LandingProperties to set.
     */
    public void setLandingPage(LandingProperties lp) {
        if(this.params == null){
            this.params = new HashMap<>();
        }
        this.params.put("apifon_lp", lp);
    }
}
