package com.apifon.sdk.model;

import java.util.ArrayList;
import java.util.List;

public abstract class SubscribersViewRequest implements IRequest {

    private List<SubscriberInformation> subscribers = new ArrayList<>();

    @Override
    public String getBody() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    /**
     * Returns the list of the Subscribers we set on the Request.
     *
     * @return the subscribers list.
     */
    public List<SubscriberInformation> getSubscribers() {
        return subscribers;
    }

    /**
     * Sets the list of the Subscribers for our Request.
     *
     * @param subscribers the subscribers list to set.
     */
    public void setSubscribers(List<SubscriberInformation> subscribers) {
        this.subscribers = subscribers;
    }

    /**
     * Adds a list of Subscribers to our Subscriber list.
     *
     * @param subscribers the subscribers list to add.
     */
    public void addSubscribers(List<SubscriberInformation> subscribers) {

        for (SubscriberInformation subInformation : subscribers) {
            this.subscribers.add(subInformation);
        }
    }

    /**
     * Adds a list of Subscribers to our Subscriber list.
     *
     * @param subscribers the subscribers list to add.
     */
    public void addStrSubscribers(List<String> subscribers) {

        for (String subscriber : subscribers) {
            SubscriberInformation tmpSub = new SubscriberInformation();
            tmpSub.setNumber(subscriber);
            this.subscribers.add(tmpSub);
        }
    }

    /**
     * Adds a Subscriber to our Subscriber list.
     *
     * @param sub the subscriber to add.
     */
    public void addSubscriber(SubscriberInformation sub) {

        this.subscribers.add(sub);
    }

    /**
     * Adds a Subscriber to our Subscriber list.
     *
     * @param number the number of a subscriber to add.
     */
    public void addStrSubscriber(String number) {

        SubscriberInformation tmpSub = new SubscriberInformation();
        tmpSub.setNumber(number);
        this.subscribers.add(tmpSub);

    }

}
