/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.apifon.sdk.model.request;

import com.apifon.sdk.resource.helpers.BounceReason;
import com.apifon.sdk.serializer.BounceReasonAdapter;
import com.google.gson.Gson;
import com.google.gson.annotations.JsonAdapter;
import com.apifon.sdk.resource.helpers.IJsonSerializable;

/**
 *
 * @author Apifon
 */
public class BounceRequestBuilder {
    
    private final String destination;
    private final BounceReason reason;
    private String description;
    
    private BounceRequestBuilder(String destination, BounceReason reason) {
        this.destination = destination;
        this.reason = reason;
    }
    
    public static BounceRequestBuilder getBounceRequestBuilder(String destination, BounceReason reason) {
        return new BounceRequestBuilder(destination, reason);
    }
    
    public BounceRequestBuilder withDescription(String description) {
        this.description = description;
        return this;
    }
    
    public BounceRequest build() {
        return new BounceRequest(this);
    }

    public static final class BounceRequest implements IJsonSerializable {

        private final String destination;
        @JsonAdapter(BounceReasonAdapter.class)
        private final BounceReason reason;
        private final String description;

        public BounceRequest(BounceRequestBuilder builder) {
            this.destination = builder.destination;
            this.reason = builder.reason;
            this.description = builder.description;
        }

        public String getDestination() {
            return destination;
        }

        public BounceReason getReason() {
            return reason;
        }

        public String getDescription() {
            return description;
        }

        @Override
        public String getBody() {
            return new Gson().toJson(this);
        }
    }
}
