/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.apifon.sdk.model.request;

import java.util.HashSet;
import java.util.Objects;
import java.util.Set;
import com.apifon.sdk.resource.helpers.IFieldSerializable;
import java.util.Collection;

/**
 *
 * @author Apifon
 */
public class BounceSingleQuery implements IFieldSerializable<BounceSingleQuery> {

    private final String destination;
    private final Set<String> fields;

    private BounceSingleQuery(String destination) {
        this.destination = destination;
        this.fields = new HashSet<>();
    }

    public static BounceSingleQuery getBounceLookup(String destination) throws NullPointerException {
        Objects.requireNonNull(destination, "Parameter destination is null.");
        return new BounceSingleQuery(destination);
    }

    @Override
    public Set<String> getFields() {
        return this.fields;
    }

    @Override
    public String getPathId() {
        return this.destination;
    }

    @Override
    public BounceSingleQuery addVisibleFields(Collection<String> fields) throws NullPointerException {
        Objects.requireNonNull(fields, "Parameter fields is null.");
        this.getFields().addAll(fields);
        return this;
    }

    @Override
    public BounceSingleQuery addVisibleField(String field) throws NullPointerException {
        Objects.requireNonNull(field, "Parameter field is null.");
        this.getFields().add(field);
        return this;
    }

}
