/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.apifon.sdk.model.request;

import com.google.gson.annotations.SerializedName;

/**
 *
 * @author Apifon
 */
public class CampaignDefaultsBuilder {

    private String senderId;
    private String viberSenderId;
    private String senderName;
    private String from;
    private String replyTo;

    private CampaignDefaultsBuilder() {
    }

    private CampaignDefaultsBuilder(CampaignDefaults campaignDefaults) {
        if (campaignDefaults == null) {
            return;
        }
        this.from = campaignDefaults.from;
        this.replyTo = campaignDefaults.replyTo;
        this.senderId = campaignDefaults.senderId;
        this.senderName = campaignDefaults.senderName;
        this.viberSenderId = campaignDefaults.viberSenderId;
    }

    public static CampaignDefaultsBuilder getBuilderFromCampaignDefaults(CampaignDefaults defaults) {
        return new CampaignDefaultsBuilder(defaults);
    }

    public static CampaignDefaultsBuilder getCampaignDefaultsBuilder() {
        return new CampaignDefaultsBuilder();
    }

    public CampaignDefaultsBuilder setSenderId(String senderId) {
        this.senderId = senderId;
        return this;
    }

    public CampaignDefaultsBuilder setViberSenderId(String viberSenderId) {
        this.viberSenderId = viberSenderId;
        return this;
    }

    public CampaignDefaultsBuilder setSenderName(String senderName) {
        this.senderName = senderName;
        return this;
    }

    public CampaignDefaultsBuilder setFrom(String from) {
        this.from = from;
        return this;
    }

    public CampaignDefaultsBuilder setReplyTo(String replyTo) {
        this.replyTo = replyTo;
        return this;
    }

    public CampaignDefaults build() {
        return new CampaignDefaults(this);
    }

    public static final class CampaignDefaults {

        @SerializedName("sender_id")
        private final String senderId;
        @SerializedName("viber_sender_id")
        private final String viberSenderId;
        @SerializedName("sender_name")
        private final String senderName;
        private final String from;
        @SerializedName("reply_to")
        private final String replyTo;

        public CampaignDefaults(CampaignDefaultsBuilder builder) {
            this.senderId = builder.senderId;
            this.senderName = builder.senderName;
            this.from = builder.from;
            this.viberSenderId = builder.viberSenderId;
            this.replyTo = builder.replyTo;
        }

        public String getSenderId() {
            return senderId;
        }

        public String getViberSenderId() {
            return viberSenderId;
        }

        public String getSenderName() {
            return senderName;
        }

        public String getFrom() {
            return from;
        }

        public String getReplyTo() {
            return replyTo;
        }
    }
}
