/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.apifon.sdk.model.request;

import com.google.gson.annotations.SerializedName;

/**
 *
 * @author Apifon
 */
public class GdprPropertiesBuilder {

    private final boolean gdprCompliant;
    private String title;
    private String description;
    private String legalText;

    private GdprPropertiesBuilder(boolean gdprCompliant) {
        this.gdprCompliant = gdprCompliant;
    }

    private GdprPropertiesBuilder(GdprProperties gdprProperties) {
        this.gdprCompliant = gdprProperties.gdprCompliant;
        this.description = gdprProperties.description;
        this.legalText = gdprProperties.legalText;
        this.title = gdprProperties.title;
    }

    public static GdprPropertiesBuilder getBuilderFromGdprProperties(GdprProperties gdprProperties) {
        return new GdprPropertiesBuilder(gdprProperties);
    }

    public static GdprPropertiesBuilder getGdprPropertiesBuilder(boolean gdprCompliant) {
        return new GdprPropertiesBuilder(gdprCompliant);
    }

    public GdprPropertiesBuilder setTitle(String title) {
        this.title = title;
        return this;
    }

    public GdprPropertiesBuilder setDescription(String description) {
        this.description = description;
        return this;
    }

    public GdprPropertiesBuilder setLegalText(String legalText) {
        this.legalText = legalText;
        return this;
    }

    public GdprProperties build() {
        return new GdprProperties(this);
    }

    public static final class GdprProperties {

        @SerializedName("gdpr_compliant")
        private final boolean gdprCompliant;
        private final String title;
        private final String description;
        @SerializedName("legal_text")
        private final String legalText;

        private GdprProperties(GdprPropertiesBuilder builder) {
            this.gdprCompliant = builder.gdprCompliant;
            this.title = builder.title;
            this.description = builder.description;
            this.legalText = builder.legalText;
        }

        public boolean isGdprCompliant() {
            return gdprCompliant;
        }

        public String getTitle() {
            return title;
        }

        public String getDescription() {
            return description;
        }

        public String getLegalText() {
            return legalText;
        }
    }
}
