package com.apifon.sdk.model.request;

import com.apifon.sdk.resource.helpers.IFieldSerializable;

import java.util.Collection;
import java.util.Objects;
import java.util.Set;

public class GroupSingleQuery implements IFieldSerializable<GroupSingleQuery> {

    private final String listId;
    private final String groupField;

    private GroupSingleQuery(String listId, String groupField){
        this.listId = listId;
        this.groupField = groupField;
    }

    public static GroupSingleQuery getGroupRequest(String listId, String groupField){
        Objects.requireNonNull(listId, "Parameter listId is null.");
        Objects.requireNonNull(groupField, "Parameter groupField is null.");
        return new GroupSingleQuery(listId,groupField);
    }


    @Override
    public GroupSingleQuery addVisibleFields(Collection<String> fields) throws NullPointerException {
        return null;
    }

    @Override
    public GroupSingleQuery addVisibleField(String field) throws NullPointerException {
        return null;
    }

    @Override
    public Set<String> getFields() {
        return null;
    }

    @Override
    public String getPathId() {
        return groupField;
    }

    public String getListId() {
        return listId;
    }
}
