/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.apifon.sdk.model.request;

import java.util.HashSet;
import java.util.Objects;
import java.util.Set;
import com.apifon.sdk.resource.helpers.IFieldSerializable;
import com.apifon.sdk.resource.helpers.IHttpEtag;
import java.util.Collection;

/**
 *
 * @author Apifon
 */
public class ListSingleQuery implements IFieldSerializable<ListSingleQuery>, IHttpEtag {

    private final String listId;
    private final Set<String> fields;
    private String etag;

    private ListSingleQuery(String listId) {
        this.listId = listId;
        this.fields = new HashSet<>();
    }
    
    public static ListSingleQuery getListRequest(String listId) throws NullPointerException {
        Objects.requireNonNull(listId, "Parameter listId is null.");
        return new ListSingleQuery(listId);
    }
    
    public ListSingleQuery withEtag(String etag) {
        this.etag = etag;
        return this;
    }

    @Override
    public Set<String> getFields() {
        return this.fields;
    }

    @Override
    public String getPathId() {
        return this.listId;
    }

    @Override
    public String getEtag() {
        return this.etag;
    }

    @Override
    public ListSingleQuery addVisibleFields(Collection<String> fields) throws NullPointerException {
        Objects.requireNonNull(fields, "Parameter fields is null.");
        this.getFields().addAll(fields);
        return this;
    }

    @Override
    public ListSingleQuery addVisibleField(String field) throws NullPointerException {
        Objects.requireNonNull(field, "Parameter field is null.");
        this.getFields().add(field);
        return this;
    }

}
