package com.apifon.sdk.model.request;

import com.apifon.sdk.resource.helpers.IFieldSerializable;

import java.util.Collection;
import java.util.Objects;
import java.util.Set;

public class SubgroupSingleQuery implements IFieldSerializable<SubgroupSingleQuery> {
    private final String listId;
    private final String groupField;
    private final String optionsField;

    private SubgroupSingleQuery(String listId, String groupField, String optionsField){
        this.listId = listId;
        this.groupField = groupField;
        this.optionsField = optionsField;
    }

    public static SubgroupSingleQuery getGroupRequest(String listId, String groupField, String optionsField){
        Objects.requireNonNull(listId, "Parameter listId is null.");
        Objects.requireNonNull(groupField, "Parameter groupField is null.");
        Objects.requireNonNull(optionsField, "Parameter optionsField is null.");
        return new SubgroupSingleQuery(listId,groupField,optionsField);
    }


    @Override
    public SubgroupSingleQuery addVisibleFields(Collection<String> fields) throws NullPointerException {
        return null;
    }

    @Override
    public SubgroupSingleQuery addVisibleField(String field) throws NullPointerException {
        return null;
    }

    @Override
    public Set<String> getFields() {
        return null;
    }

    @Override
    public String getPathId() {
        return optionsField;
    }

    public String getListId() {
        return listId;
    }

    public String getGroupField() {
        return groupField;
    }
}
