/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.apifon.sdk.model.request;

import com.apifon.sdk.resource.helpers.IFieldSerializable;
import java.util.Collection;
import java.util.HashSet;
import java.util.Objects;
import java.util.Set;

/**
 *
 * @author Apifon
 */
public class SubscriberSingleQuery implements IFieldSerializable<SubscriberSingleQuery> {

    private final String lookupMD5;
    private final String listId;
    private final Set<String> fields;

    private SubscriberSingleQuery(String lookupMD5, String listId) {
        this.lookupMD5 = lookupMD5;
        this.listId = listId;
        this.fields = new HashSet<>();
    }

    public static SubscriberSingleQuery getSubscriberLookup(String lookupMD5, String listId) {
        return new SubscriberSingleQuery(lookupMD5, listId);
    }

    public String getListId() {
        return listId;
    }

    @Override
    public Set<String> getFields() {
        return this.fields;
    }

    @Override
    public String getPathId() {
        return this.lookupMD5;
    }

    @Override
    public SubscriberSingleQuery addVisibleFields(Collection<String> fields) throws NullPointerException {
        Objects.requireNonNull(fields, "Parameter fields is null.");
        this.getFields().addAll(fields);
        return this;
    }

    @Override
    public SubscriberSingleQuery addVisibleField(String field) throws NullPointerException {
        Objects.requireNonNull(field, "Parameter field is null.");
        this.getFields().add(field);
        return this;
    }

}
