package com.apifon.sdk.resource;

import com.apifon.sdk.response.BalanceResponse;

import com.google.gson.Gson;

/**
 * BalanceResource class is used get your Account's balance. Call the send()
 * method to get information about your balance.
 */
public class BalanceResource extends AbstractResource {

    public BalanceResource() {
        super("/services/api/v1/balance");
    }

    /**
     * This method is used to get your account credit balance.
     *
     * @return A java object with the information about the account Balance and
     * Plafon.
     */
    public BalanceResponse send() {
        Gson gson = new Gson();

        this.setCurMethod("POST");
        this.setCurEndpoint(this.getEndpoint());
        this.setCurBody(null);

        return gson.fromJson(this.dispatch(), BalanceResponse.class);
    }

}
