/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.apifon.sdk.resource;

import com.apifon.sdk.exception.ApifonRestException;
import com.apifon.sdk.model.CollectionEntityResponse;
import com.apifon.sdk.model.request.GdprFieldRequestBuilder;
import com.apifon.sdk.response.GdprFieldResponse;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import java.io.IOException;
import java.net.URI;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.apache.http.HttpEntity;
import org.apache.http.HttpHeaders;
import org.apache.http.HttpResponse;
import org.apache.http.util.EntityUtils;

/**
 *
 * @author Apifon
 */
public class GdprFieldResource extends AbstractResource {

    public GdprFieldResource() {
        super("/services/api/v1/list/{list_id}/gdpr");
    }

    /**
     * @param endpoint the curEndpoint to set
     * @param listId the list ID
     */
    public void replacePlaceholderAndSetUrl(String endpoint, String listId) {
        super.setCurEndpoint(endpoint.replace("{list_id}", listId));
    }

    public URI addGdprField(GdprFieldRequestBuilder.GdprFieldRequest request) throws ApifonRestException {
        this.setCurMethod("POST");
        this.replacePlaceholderAndSetUrl(this.getEndpoint() + "/", request.getListId());
        this.setCurBody(request.getBody());
        HttpResponse response = this.dispatchToResponse();
        return URI.create(response.getFirstHeader(HttpHeaders.LOCATION).getValue());
    }

    public URI updateGdprField(GdprFieldRequestBuilder.GdprFieldRequest request) throws ApifonRestException {
        this.setCurMethod("PUT");
        this.replacePlaceholderAndSetUrl(this.getEndpoint() + "/" + request.getField(), request.getListId());
        this.setCurBody(request.getBody());
        HttpResponse response = this.dispatchToResponse();
        return URI.create(response.getFirstHeader(HttpHeaders.LOCATION).getValue());
    }
    
}
