/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.apifon.sdk.resource;

import com.apifon.sdk.exception.ApifonRestException;
import com.apifon.sdk.model.CollectionEntityResponse;
import java.net.URI;

/**
 * Describes a resource that is accessible by URIs returned from Apifon REST API.
 * @author Apifon
 * @param <T> the Class of the entity
 */
public interface UriLocator<T> {
    
    /**
     * Gets a single entity response from the given resource URI.
     * @param resourceUri the URI describing the resource.
     * @return An entity
     * @throws ApifonRestException if an exception is thrown from the API call (Unparsable request, Resource not found etc)
     */
    public abstract T getByResourceUri(URI resourceUri) throws ApifonRestException;
    
    /**
     * Gets a CollectionEntityResponse containing a list of entities from the given resource URI.
     * @param resourceUri  the URI describing the resource.
     * @return CollectionEntityResponse containing a list of entities
     * @throws ApifonRestException if an exception is thrown from the API call (Unparsable request, Resource not found etc)
     */
    public abstract CollectionEntityResponse<T> getListByResouceUri(URI resourceUri) throws ApifonRestException;

}
