/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.apifon.sdk.resource.helpers;

/**
 * An enum describing reasons for a subscriber to be bounced.
 * @author Apifon
 */
public enum BounceReason {

    /**
     * Bounced for other reasons.
     */
    OTHER("other"),
    /**
     * Bounced due to messages not delivering.
     */
    NOT_DELIVERING("not_delivering"),
    /**
     * Bounced due to subscriber deleted.
     */
    SUBSCRIBER_DELETE("sub_deleted"),
    /**
     * Bounced because subscriber requested.
     */
    SUBSCRIBER_REQUESTED("sub_requested"),
    /**
     * Bounced because the subscriber is invalid.
     */
    SUBSCRIBER_INVALID("sub_invalid");

    private final String value;
    
    public static BounceReason parse(String value) {
        for (BounceReason reason : BounceReason.values()) {
            if (reason.getValue().equals(value)) {
                return reason;
            }
        }
        return BounceReason.OTHER;
    }

    private BounceReason(String value) {
        this.value = value;
    }

    public final String getValue() {
        return this.value;
    }

}
