/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.apifon.sdk.resource.helpers;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Objects;
import java.util.Set;
import java.util.stream.Collectors;
import org.apache.http.NameValuePair;
import org.apache.http.client.utils.URIBuilder;
import org.apache.http.message.BasicNameValuePair;

/**
 *
 * @author Apifon
 */
public interface IFieldSerializable<T> {

    public abstract T addVisibleFields(Collection<String> fields) throws NullPointerException;

    public abstract T addVisibleField(String field) throws NullPointerException;
    
    default public String getQueryParams() {
        List<NameValuePair> queryParams = new ArrayList<>();
        if (getFields() != null && !getFields().isEmpty()) {
            queryParams.add(new BasicNameValuePair("fields", getFields().stream().collect(Collectors.joining(","))));
        }
        return new URIBuilder().setParameters(queryParams).toString();
    }

    public abstract Set<String> getFields();
    
    public abstract String getPathId();
}
