/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.apifon.sdk.resource.helpers;

import java.util.List;
import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;

/**
 * Represents a paginated request with default values that can be overriden.
 * @author Apifon
 */
public abstract class PaginatedRequest {
    
    protected int page = 1;
    protected int size = 20;
    protected String sortField = "id";
    protected SortDirection sortDir = SortDirection.ASC;
    
    public abstract String toQueryParamRequest();
    
    public String getPathId() {
        return null;
    }
    
    protected void addQueryParams(List<NameValuePair> queryParams) {
        queryParams.add(new BasicNameValuePair("size", String.valueOf(size)));
        queryParams.add(new BasicNameValuePair("page", String.valueOf(page)));
        queryParams.add(new BasicNameValuePair("sort", sortField));
        queryParams.add(new BasicNameValuePair("sort_dir", sortDir.name()));
    }
}
