/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.apifon.sdk.resource.helpers;

import java.util.Objects;

/**
 *
 * @author Apifon
 */
public abstract class PaginatedRequestBuilder extends PaginatedRequest {

    public PaginatedRequestBuilder setPage(int page) throws IllegalArgumentException {
        if (page < 0) {
            throw new IllegalArgumentException("Parameter page must be a positive value.");
        }
        this.page = page;
        return this;
    }

    public PaginatedRequestBuilder setSize(int size) throws IllegalArgumentException {
        if (size < 0) {
            throw new IllegalArgumentException("Parameter size must be a positive value.");
        }
        this.size = size;
        return this;
    }
    
    public PaginatedRequestBuilder setSort(String sortField, SortDirection sortDirection) throws NullPointerException {
        Objects.requireNonNull(sortField, "Parameter sortField is null.");
        Objects.requireNonNull(sortDirection, "Parameter sortDirection is null");
        this.sortDir = sortDirection;
        this.sortField = sortField;
        return this;
    }
    
    public abstract PaginatedRequest build();

}
