/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.apifon.sdk.resource.helpers;

/**
 *
 * @author Apifon
 */
public enum SubscriberFieldDateFormat {

    /**
     * Date format : dd-MM-yy<br>
     * Example : 16-02-91, 26-09-1998
     */
    dd_mm_yyyy("dd-MM-yy"),
    /**
     * Date format : yy-MM-dd<br>
     * Example : 90-01-13, 2011-06-10
     */
    yyyy_mm_dd("yy-MM-dd"),
    /**
     * Date format : MM-dd-yy<br>
     * Example : 10-26-02, 11-01-2018
     */
    mm_dd_yyyy("MM-dd-yy"),
    /**
     * Date format : dd/MM/yy<br>
     * Example : 10/02/16, 30/05/2001
     */
    shlash_dd_mm_yyyy("dd/MM/yy"),
    /**
     * Date format : yy/MM/dd<br>
     * Example : 90/01/13, 2011/06/10
     */
    shlash_yyyy_mm_dd("yy/MM/dd"),
    /**
     * Date format : MM/dd/yy<br>
     * Example : 10/26/02, 11/01/2018
     */
    shlash_mm_dd_yyyy("MM/dd/yy");

    private final String value;

    private SubscriberFieldDateFormat(String value) {
        this.value = value;
    }

    public String getValue() {
        return value;
    }

    public static SubscriberFieldDateFormat parseFromString(String value) throws IllegalArgumentException {
        if (value == null) {
            return null;
        }
        for (SubscriberFieldDateFormat c : SubscriberFieldDateFormat.values()) {
            if (c.getValue().equals(value)) {
                return c;
            }
        }
        throw new IllegalArgumentException("Value " + value + " is not a valid SubscriberFieldDateFormat");
    }
}
