/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.apifon.sdk.response;

import com.google.gson.annotations.SerializedName;
import java.util.Map;

/**
 * A model representing an error response from Apifon REST API.
 * @author Apifon
 */
public class ApiErrorResponse {

    /**
     * The status of the response. Matches the HTTP Status code of the response.
     */
    public int status;
    /**
     * A short human readable general information about the error.
     */
    public String title;
    /**
     * Contains descriptive messages about any error(s) occured.
     */
    @SerializedName("error_details")
    public Map<String, String> errorDetails;
    /**
     * A unique identifier for the error. Useful for debugging/tracking purposes.
     */
    @SerializedName("error_report_code")
    public String errorReportCode;
    
    public static ApiErrorResponse getOAuthTokenResponse() {
        ApiErrorResponse response = new ApiErrorResponse();
        response.status = 401;
        response.title = "Unauthorized";
        return response;
    }

    /**
     * The status of the response. Matches the HTTP Status code of the response.
     * @return 
     */
    public int getStatus() {
        return status;
    }

    /**
     * A short human readable general information about the error.
     * @return 
     */
    public String getTitle() {
        return title;
    }

    /**
     * Contains descriptive messages about any error(s) occured.
     * @return 
     */
    public Map<String, String> getErrorDetails() {
        return errorDetails;
    }

    /**
     * A unique identifier for the error. Useful for debugging/tracking purposes.
     * @return 
     */
    public String getErrorReportCode() {
        return errorReportCode;
    }
}
