package com.apifon.sdk.response;

import java.util.Collections;
import java.util.List;

/**
 * BalanceResponse class is the response we get when we send a Request to be
 * informed about our Balance.
 */
public class BalanceResponse {

    private String balance;
    private String plafon;
    private String reserved;
    private List<SubscriptionResponse> subscriptions;

    /**
     * Returns the Balance of the account the Credentials link to.
     *
     * @return the Balance.
     */
    public String getBalance() {
        return balance;
    }

    /**
     * Returns the Plafon of the account the Credentials link to.
     *
     * @return the Plafon.
     */
    public String getPlafon() {
        return plafon;
    }

    public String getReserved() {
        return reserved;
    }

    /**
     * @return An array of your subscriptions or an empty array if none exists.
     */
    public List<SubscriptionResponse> getSubscriptions() {
        return (subscriptions == null || subscriptions.isEmpty())
                ? Collections.EMPTY_LIST
                : this.subscriptions;
    }

    @Override
    public String toString() {
        return "BalanceResponse{" + "balance=" + balance + ", plafon=" + plafon + ", reserved=" + reserved + ", subscriptions=" + subscriptions + '}';
    }
}
