package com.apifon.sdk.response;

import com.google.gson.annotations.SerializedName;
import java.util.HashMap;
import java.util.List;

/**
 * GatewayResponse class is the Response we get when we send an SMS or IM
 * Request.
 */
public class GatewayResponse {

    @SerializedName("request_id")
    private String requestId;
    @SerializedName(value = "reference_id", alternate = "reference")
    private String reference_id;
    private HashMap<String, List<ResultDetails>> results;
    @SerializedName("result_info")
    private ResultInfo resultInfo;

    /**
     * Returns the requestId of the Request.
     *
     * @return the requestId.
     */
    public String getRequestId() {
        return requestId;
    }

    /**
     * Returns the referenceID of the Request.
     *
     * @return the reference.
     */
    public String getReferenceId() {
        return reference_id;
    }

    /**
     * Returns the results of the Request.
     *
     * @return the results.
     */
    public HashMap<String, List<ResultDetails>> getResults() {
        return results;
    }

    /**
     * Returns the resultInfo of the Request.
     *
     * @return the resultInfo.
     */
    public ResultInfo getResultInfo() {
        return resultInfo;
    }
}
