package com.apifon.sdk.response;

import com.google.gson.annotations.SerializedName;
import java.util.List;

/**
 * OtpResponse class is the Response we get when we send an OTP code creation Request.
 */
public class OtpResponse {

    @SerializedName("request_id")
    private String requestId;
    @SerializedName("reference_id")
    private String referenceId;
    private List<ResultDetails> result;
    @SerializedName("result_info")
    private ResultInfo resultInfo;

    /**
     * Returns the requestId of the Request.
     *
     * @return the requestId.
     */
    public String getRequestId() {
        return requestId;
    }

    /**
     * Returns the referenceID of the Request.
     *
     * @return the reference.
     */
    public String getReferenceId() {
        return referenceId;
    }

    /**
     * Returns the results of the Request.
     *
     * @return the results.
     */
    public List<ResultDetails> getResult() {
        return result;
    }

    /**
     * Returns the resultInfo of the Request.
     *
     * @return the resultInfo.
     */
    public ResultInfo getResultInfo() {
        return resultInfo;
    }
}
