package com.apifon.sdk.response;

import com.google.gson.annotations.SerializedName;

/**
 * ResultDetails class represents the results Property in an SMS or IM Response.
 */
public class ResultDetails {

    @SerializedName("message_id")
    private String messageId;
    @SerializedName("custom_id")
    private String customId;
    private int length;
    @SerializedName("short_code")
    private String shortCode;
    @SerializedName("short_url")
    private String shortUrl;

    /**
     * Returns the messageId of the specific result.
     *
     * @return the messageId.
     */
    public String getMessageId() {
        return messageId;
    }

    /**
     * Returns the customId of the specific result.
     *
     * @return the customId.
     */
    public String getCustomId() {
        return customId;
    }

    /**
     * Returns the length of the specific result.
     *
     * @return the length.
     */
    public int getLength() {
        return length;
    }

    /**
     * Returns the shortCode of the specific result.
     *
     * @return the shortCode.
     */
    public String getShortCode() {
        return shortCode;
    }

    /**
     * Returns the shortUrl of the specific result.
     *
     * @return the shortUrl.
     */
    public String getShortUrl() {
        return shortUrl;
    }
}
