/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.apifon.sdk.tests;

import com.apifon.sdk.exception.ApifonRestException;
import com.apifon.sdk.exception.OAuthException;
import com.apifon.sdk.resource.BounceListResource;
import com.apifon.sdk.resource.helpers.OpenIDScope;
import com.apifon.sdk.response.BounceResponse;
import java.net.URI;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

/**
 *
 * @author Apifon
 */
public class OAuthClientCredentialsTest extends BaseTest {

    @Before
    public void init() throws OAuthException {
        super.setup();
        initMookee();
    }

    @Test(expected = Test.None.class)
    public void test_InvalidScope() throws ApifonRestException, OAuthException {
        try {
            setValidOAuth(OpenIDScope.IM_GATEWAY);
            BounceListResource resource = new BounceListResource();
            resource.addBounceSubscriber(getAddBounceRequest());
        } catch (ApifonRestException ex) {
            Assert.assertEquals(401, ex.getResp().status);
        }
    }

    @Test(expected = Test.None.class)
    public void test_Add_thenRetrieve_thenDelete_BounceAPI() throws ApifonRestException, OAuthException {
        setValidOAuth(OpenIDScope.WRITE_SUBSCRIBER);
        BounceListResource resource = new BounceListResource();
        // Add
        URI addBounceSubscriber = resource.addBounceSubscriber(getAddBounceRequest());
        Assert.assertNotNull(addBounceSubscriber);
        // Retrieve
        BounceResponse addedBounce = resource.getByResourceUri(addBounceSubscriber);
        Assert.assertEquals(BLOCK_DESTINATION, addedBounce.getDestination());
        // Delete
        boolean removed = resource.removeBounceSubscriber(addedBounce.getDestination());
        Assert.assertTrue(removed);
    }

}
